Index: /trunk/sources/HeuristicLab 3.3/CopyAssemblies.cmd
===================================================================
--- /trunk/sources/HeuristicLab 3.3/CopyAssemblies.cmd	(revision 2642)
+++ /trunk/sources/HeuristicLab 3.3/CopyAssemblies.cmd	(revision 2643)
@@ -1,41 +1,21 @@
-copy "%SolutionDir%\HeuristicLab.PluginInfrastructure.GUI\ICSharpCode.SharpZipLib License.txt" .\
+FOR /F "skip=1 tokens=1-2 delims=: usebackq" %%G IN ("%ProjectDir%\Files.txt") DO echo "%%H" && copy "%SolutionDir%\%%G\%Outdir%\%%H" .\
 
-rmdir plugins /s /q
-mkdir plugins
-mkdir plugins\cache
-mkdir plugins\temp
-mkdir plugins\backup
 
-copy "%SolutionDir%\HeuristicLab.Charting\3.3\%Outdir%\HeuristicLab.Charting-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Charting.Data\3.3\%Outdir%\HeuristicLab.Charting.Data-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Collections\3.3\%Outdir%\HeuristicLab.Collections-3.3.dll" .\plugins 
-copy "%SolutionDir%\HeuristicLab.Common\3.2\%Outdir%\HeuristicLab.Common-3.2.dll" .\plugins 
-copy "%SolutionDir%\HeuristicLab.Common.Resources\3.2\%Outdir%\HeuristicLab.Common.Resources-3.2.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Core\3.3\%Outdir%\HeuristicLab.Core-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Core.Views\3.3\%Outdir%\HeuristicLab.Core.Views-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Data\3.3\%Outdir%\HeuristicLab.Data-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Evolutionary\3.3\%Outdir%\HeuristicLab.Evolutionary-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Logging\3.3\%Outdir%\HeuristicLab.Logging-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.MainForm\3.2\%Outdir%\HeuristicLab.MainForm-3.2.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.MainForm.Test\3.2\%Outdir%\HeuristicLab.MainForm.Test-3.2.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.MainForm.WindowsForms\3.2\%Outdir%\HeuristicLab.MainForm.WindowsForms-3.2.dll" .\plugins
-copy "%SolutionDir%\WinFormsUI\%Outdir%\WeifenLuo.WinFormsUI.Docking.dll" .\plugins
-copy "%SolutionDir%\WinFormsUI\%Outdir%\WeifenLuo.WinFormsUI.Docking License.txt" .\plugins
-copy "%SolutionDir%\HeuristicLab.Operators\3.3\%Outdir%\HeuristicLab.Operators-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Operators.Programmable\3.3\%Outdir%\HeuristicLab.Operators.Programmable-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Optimizer\3.3\%Outdir%\HeuristicLab.Optimizer-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Permutation\3.3\%Outdir%\HeuristicLab.Permutation-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Persistence\3.3\%Outdir%\HeuristicLab.Persistence-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Persistence.GUI\3.3\%Outdir%\HeuristicLab.Persistence.GUI-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Random\3.3\%Outdir%\HeuristicLab.Random-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Routing.TSP\3.3\%Outdir%\HeuristicLab.Routing.TSP-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Selection\3.3\%Outdir%\HeuristicLab.Selection-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Selection.OffspringSelection\3.3\%Outdir%\HeuristicLab.Selection.OffspringSelection-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.SequentialEngine\3.3\%Outdir%\HeuristicLab.SequentialEngine-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.SGA\3.3\%Outdir%\HeuristicLab.SGA-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.TestFunctions\3.3\%Outdir%\HeuristicLab.TestFunctions-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.ThreadParallelEngine\3.3\%Outdir%\HeuristicLab.ThreadParallelEngine-3.3.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Tracing\3.2\%Outdir%\HeuristicLab.Tracing-3.2.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Tracing\3.2\%Outdir%\log4net.dll" .\plugins
-copy "%SolutionDir%\HeuristicLab.Tracing\3.2\log4net licence.txt" .\plugins
-copy "%SolutionDir%\HeuristicLab.Tracing\3.2\HeuristicLab.log4net.xml" .\plugins
+echo "Platform: %Platform%, architecture: %PROCESSOR_ARCHITECTURE%"
+if "%Platform%" == "x86" (   
+  FOR /F "skip=1 tokens=* usebackq" %%G IN ("%ProjectDir%\Files.x86.txt") DO echo "%%G" && copy "%SolutionDir%\%%G" .\
+) else if "%Platform%" == "x64" ( 
+  FOR /F "skip=1 tokens=* usebackq" %%G IN ("%ProjectDir%\Files.x64.txt") DO echo "%%G" && copy "%SolutionDir%\%%G" .\
+) else if "%Platform%" == "AnyCPU" (
+  if "%PROCESSOR_ARCHITECTURE%" == "x64" (
+  FOR /F "skip=1 tokens=* usebackq" %%G IN ("%ProjectDir%\Files.x64.txt") DO echo "%%G" && copy "%SolutionDir%\%%G" .\
+  ) else if "%PROCESSOR_ARCHITECTURE%" == "x86" (
+  FOR /F "skip=1 tokens=* usebackq" %%G IN ("%ProjectDir%\Files.x86.txt") DO echo "%%G" && copy "%SolutionDir%\%%G" .\
+  ) else (
+    echo "ERROR: unknown architecture: "%PROCESSOR_ARCHITECTURE%"
+  ) 
+) else (
+  echo "ERROR: unknown platform: %Platform%"
+)
+
+echo "CopyAssemblies done"
Index: /trunk/sources/HeuristicLab 3.3/CreateConsoleApplication.cmd
===================================================================
--- /trunk/sources/HeuristicLab 3.3/CreateConsoleApplication.cmd	(revision 2643)
+++ /trunk/sources/HeuristicLab 3.3/CreateConsoleApplication.cmd	(revision 2643)
@@ -0,0 +1,24 @@
+copy HeuristicLab.exe HeuristicLab.Console.exe
+
+echo "Platform: %Platform%, architecture: %PROCESSOR_ARCHITECTURE%"
+if "%Platform%" == "x86" (   
+ @call "c:\Program Files\Microsoft Visual Studio 9.0\VC\vcvarsall.bat" x86
+ @call "c:\Program Files\Microsoft Visual Studio 9.0\VC\bin\editbin.exe" /subsystem:console HeuristicLab.Console.exe
+) else if "%Platform%" == "x64" ( 
+  @call "c:\Program Files (x86)\Microsoft Visual Studio 9.0\VC\vcvarsall.bat" x64
+  @call "c:\Program Files (x86)\Microsoft Visual Studio 9.0\VC\bin\editbin.exe" /subsystem:console HeuristicLab.Console.exe
+) else if "%Platform%" == "AnyCPU" (
+ if "%PROCESSOR_ARCHITECTURE%" == "x64" (
+   @call "c:\Program Files (x86)\Microsoft Visual Studio 9.0\VC\vcvarsall.bat" x64
+   @call "c:\Program Files (x86)\Microsoft Visual Studio 9.0\VC\bin\editbin.exe" /subsystem:console HeuristicLab.Console.exe
+  ) else if "%PROCESSOR_ARCHITECTURE%" == "x86" (
+   @call "c:\Program Files\Microsoft Visual Studio 9.0\VC\vcvarsall.bat" x86
+   @call "c:\Program Files\Microsoft Visual Studio 9.0\VC\bin\editbin.exe" /subsystem:console HeuristicLab.Console.exe
+  ) else (
+      echo "ERROR: unknown architecture: "%PROCESSOR_ARCHITECTURE%"
+  ) 
+) else (
+  echo "ERROR: unknown platform: %Platform%"
+)
+
+echo "Done creating console application"
Index: /trunk/sources/HeuristicLab 3.3/CustomPostBuildTemplate_UpdateLocalInstallation.cmd
===================================================================
--- /trunk/sources/HeuristicLab 3.3/CustomPostBuildTemplate_UpdateLocalInstallation.cmd	(revision 2642)
+++ /trunk/sources/HeuristicLab 3.3/CustomPostBuildTemplate_UpdateLocalInstallation.cmd	(revision 2643)
@@ -1,11 +1,28 @@
-set target=C:\Program Files\HeuristicLab 3.3
+set target=C:\Program Files\HeuristicLab 3.0
 
-copy "HeuristicLab.exe" "%target%"
-copy "HeuristicLab 3.3.exe" "%target%"
-copy "HeuristicLab 3.3.exe.config" "%target%"
-copy "HeuristicLab.PluginInfrastructure.dll" "%target%"
-copy "HeuristicLab.PluginInfrastructure.GUI.dll" "%target%"
-copy "ICSharpCode.SharpZipLib.dll" "%target%"
-copy "ICSharpCode.SharpZipLib License.txt" "%target%"
-rmdir /s /q "%target%\plugins"
-xcopy "plugins" "%target%\plugins" /e /i
+copy HeuristicLab.exe "%target%"
+copy HeuristicLab.Console.exe "%target%"
+copy HeuristicLab.exe.config "%target%"
+copy HeuristicLab.PluginInfrastructure.dll "%target%"
+
+FOR /F "skip=1 tokens=1-2 delims=: usebackq" %%G IN ("%ProjectDir%\Files.txt") DO copy "%SolutionDir%\%%G\%Outdir%\%%H" "%target%" >nul
+
+
+echo "Platform: %Platform%, architecture: %PROCESSOR_ARCHITECTURE%"
+if "%Platform%" == "x86" (   
+  FOR /F "skip=1 tokens=* usebackq" %%G IN ("%ProjectDir%\Files.x86.txt") DO copy "%SolutionDir%\%%G" "%target%" >nul
+) else if "%Platform%" == "x64" ( 
+  FOR /F "skip=1 tokens=* usebackq" %%G IN ("%ProjectDir%\Files.x64.txt") DO copy "%SolutionDir%\%%G" "%target%" >nul
+) else if "%Platform%" == "AnyCPU" (
+  if "%PROCESSOR_ARCHITECTURE%" == "x64" (
+  FOR /F "skip=1 tokens=* usebackq" %%G IN ("%ProjectDir%\Files.x64.txt") DO copy "%SolutionDir%\%%G" "%target%" >nul
+  ) else if "%PROCESSOR_ARCHITECTURE%" == "x86" (
+  FOR /F "skip=1 tokens=* usebackq" %%G IN ("%ProjectDir%\Files.x86.txt") DO copy "%SolutionDir%\%%G" "%target%" >nul
+  ) else (
+    echo "ERROR: unknown architecture: "%PROCESSOR_ARCHITECTURE%"
+  ) 
+) else (
+  echo "ERROR: unknown platform: %Platform%"
+)
+
+echo "CustomPostBuild done"
Index: /trunk/sources/HeuristicLab 3.3/Files.txt
===================================================================
--- /trunk/sources/HeuristicLab 3.3/Files.txt	(revision 2643)
+++ /trunk/sources/HeuristicLab 3.3/Files.txt	(revision 2643)
@@ -0,0 +1,38 @@
+﻿; This line is skipped. DO NOT TOUCH THIS line!
+; List of project directories and file names separated by ':' that are part of the installation
+
+HeuristicLab.PluginInfrastructure:ICSharpCode.SharpZipLib.dll
+HeuristicLab.PluginInfrastructure:ICSharpCode.SharpZipLib License.txt
+HeuristicLab.Charting\3.3:HeuristicLab.Charting-3.3.dll 
+HeuristicLab.Charting.Data\3.3:HeuristicLab.Charting.Data-3.3.dll 
+HeuristicLab.Collections\3.3:HeuristicLab.Collections-3.3.dll 
+HeuristicLab.Common\3.2:HeuristicLab.Common-3.2.dll  
+HeuristicLab.Common.Resources\3.2:HeuristicLab.Common.Resources-3.2.dll 
+HeuristicLab.Core\3.3:HeuristicLab.Core-3.3.dll 
+HeuristicLab.Core.Views\3.3:HeuristicLab.Core.Views-3.3.dll 
+HeuristicLab.Data\3.3:HeuristicLab.Data-3.3.dll 
+HeuristicLab.Evolutionary\3.3:HeuristicLab.Evolutionary-3.3.dll 
+HeuristicLab.Logging\3.3:HeuristicLab.Logging-3.3.dll 
+HeuristicLab.MainForm\3.2:HeuristicLab.MainForm-3.2.dll 
+HeuristicLab.MainForm.Test\3.2:HeuristicLab.MainForm.Test-3.2.dll 
+HeuristicLab.MainForm.WindowsForms\3.2:HeuristicLab.MainForm.WindowsForms-3.2.dll 
+HeuristicLab.Operators\3.3:HeuristicLab.Operators-3.3.dll 
+HeuristicLab.Operators.Programmable\3.3:HeuristicLab.Operators.Programmable-3.3.dll 
+HeuristicLab.Optimizer\3.3:HeuristicLab.Optimizer-3.3.dll 
+HeuristicLab.Permutation\3.3:HeuristicLab.Permutation-3.3.dll 
+HeuristicLab.Persistence\3.3:HeuristicLab.Persistence-3.3.dll 
+HeuristicLab.Persistence.GUI\3.3:HeuristicLab.Persistence.GUI-3.3.dll 
+HeuristicLab.Random\3.3:HeuristicLab.Random-3.3.dll 
+HeuristicLab.Routing.TSP\3.3:HeuristicLab.Routing.TSP-3.3.dll 
+HeuristicLab.Selection\3.3:HeuristicLab.Selection-3.3.dll 
+HeuristicLab.Selection.OffspringSelection\3.3:HeuristicLab.Selection.OffspringSelection-3.3.dll 
+HeuristicLab.SequentialEngine\3.3:HeuristicLab.SequentialEngine-3.3.dll 
+HeuristicLab.SGA\3.3:HeuristicLab.SGA-3.3.dll 
+HeuristicLab.TestFunctions\3.3:HeuristicLab.TestFunctions-3.3.dll 
+HeuristicLab.ThreadParallelEngine\3.3:HeuristicLab.ThreadParallelEngine-3.3.dll 
+HeuristicLab.Tracing\3.2:HeuristicLab.Tracing-3.2.dll 
+HeuristicLab.Tracing\3.2:log4net.dll 
+HeuristicLab.Tracing\3.2:log4net licence.txt 
+HeuristicLab.Tracing\3.2:HeuristicLab.log4net.xml 
+WinFormsUI:WeifenLuo.WinFormsUI.Docking.dll 
+WinFormsUI:WeifenLuo.WinFormsUI.Docking License.txt 
Index: /trunk/sources/HeuristicLab 3.3/Files.x64.txt
===================================================================
--- /trunk/sources/HeuristicLab 3.3/Files.x64.txt	(revision 2643)
+++ /trunk/sources/HeuristicLab 3.3/Files.x64.txt	(revision 2643)
@@ -0,0 +1,3 @@
+﻿; This line is skipped. DO NOT TOUCH THIS line!
+; This file contains a list of all x86 specific files
+
Index: /trunk/sources/HeuristicLab 3.3/Files.x86.txt
===================================================================
--- /trunk/sources/HeuristicLab 3.3/Files.x86.txt	(revision 2643)
+++ /trunk/sources/HeuristicLab 3.3/Files.x86.txt	(revision 2643)
@@ -0,0 +1,3 @@
+﻿; This line is skipped. DO NOT TOUCH THIS line!
+; This file contains a list of all x86 specific files
+
Index: /trunk/sources/HeuristicLab 3.3/HeuristicLab 3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab 3.3/HeuristicLab 3.3.csproj	(revision 2642)
+++ /trunk/sources/HeuristicLab 3.3/HeuristicLab 3.3.csproj	(revision 2643)
@@ -9,11 +9,11 @@
     <OutputType>WinExe</OutputType>
     <AppDesignerFolder>Properties</AppDesignerFolder>
-    <RootNamespace>HeuristicLab33</RootNamespace>
-    <AssemblyName>HeuristicLab 3.3</AssemblyName>
+    <RootNamespace>HeuristicLab</RootNamespace>
+    <AssemblyName>HeuristicLab</AssemblyName>
     <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
     <FileAlignment>512</FileAlignment>
     <SignAssembly>true</SignAssembly>
     <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
-    <StartupObject>HeuristicLab33.Program</StartupObject>
+    <StartupObject>HeuristicLab.Program</StartupObject>
     <RunPostBuildEvent>Always</RunPostBuildEvent>
     <ApplicationIcon>HeuristicLab.ico</ApplicationIcon>
@@ -68,4 +68,5 @@
     <None Include="app.config" />
     <None Include="CopyAssemblies.cmd" />
+    <None Include="CreateConsoleApplication.cmd" />
     <None Include="CustomPostBuild.cmd" />
     <None Include="CustomPostBuildTemplate_UpdateLocalInstallation.cmd" />
@@ -84,10 +85,16 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\HeuristicLab\HeuristicLab.csproj">
-      <Project>{623FB817-8371-4A9A-A491-4DECC87B2BBB}</Project>
-      <Name>HeuristicLab</Name>
+    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
     </ProjectReference>
   </ItemGroup>
   <ItemGroup>
+    <Content Include="Files.txt">
+    </Content>
+    <Content Include="Files.x64.txt">
+    </Content>
+    <Content Include="Files.x86.txt">
+    </Content>
     <Content Include="HeuristicLab.ico" />
   </ItemGroup>
@@ -115,4 +122,5 @@
 set Configuration=$(ConfigurationName)
 
+call CreateConsoleApplication.cmd
 call MergeConfigs.cmd
 call CopyAssemblies.cmd
Index: /trunk/sources/HeuristicLab 3.3/MergeConfigs.cmd
===================================================================
--- /trunk/sources/HeuristicLab 3.3/MergeConfigs.cmd	(revision 2642)
+++ /trunk/sources/HeuristicLab 3.3/MergeConfigs.cmd	(revision 2643)
@@ -1,4 +1,3 @@
-ConfigMerger "%SolutionDir%\HeuristicLab.PluginInfrastructure\%Outdir%\HeuristicLab.PluginInfrastructure.dll.config" "HeuristicLab 3.3.exe.config"
-ConfigMerger "%SolutionDir%\HeuristicLab.PluginInfrastructure.GUI\%Outdir%\HeuristicLab.PluginInfrastructure.GUI.dll.config" "HeuristicLab 3.3.exe.config"
-ConfigMerger "%SolutionDir%\HeuristicLab.Persistence\3.3\%Outdir%\HeuristicLab.Persistence-3.3.dll.config" "HeuristicLab 3.3.exe.config"
-ConfigMerger "%SolutionDir%\HeuristicLab.Tracing\3.2\%Outdir%\HeuristicLab.Tracing-3.2.dll.config" "HeuristicLab 3.3.exe.config"
+ConfigMerger "%SolutionDir%\HeuristicLab.PluginInfrastructure\%Outdir%\HeuristicLab.PluginInfrastructure.dll.config" "HeuristicLab.exe.config"
+ConfigMerger "%SolutionDir%\HeuristicLab.Persistence\3.3\%Outdir%\HeuristicLab.Persistence-3.3.dll.config" "HeuristicLab.exe.config"
+ConfigMerger "%SolutionDir%\HeuristicLab.Tracing\3.2\%Outdir%\HeuristicLab.Tracing-3.2.dll.config" "HeuristicLab.exe.config"
Index: /trunk/sources/HeuristicLab 3.3/Program.cs
===================================================================
--- /trunk/sources/HeuristicLab 3.3/Program.cs	(revision 2642)
+++ /trunk/sources/HeuristicLab 3.3/Program.cs	(revision 2643)
@@ -26,35 +26,11 @@
 using System.Text;
 using HeuristicLab;
+using HeuristicLab.PluginInfrastructure.Starter;
 
-namespace HeuristicLab33 {
+namespace HeuristicLab {
   static class Program {
     [STAThread]
     static void Main(string[] args) {
-      try {
-        Application.EnableVisualStyles();
-        Application.SetCompatibleTextRenderingDefault(false);
-        Application.Run(new MainForm());
-      }
-      catch (Exception ex) {
-        ShowErrorMessageBox(ex);
-      }
-    }
-
-    public static void ShowErrorMessageBox(Exception ex) {
-      MessageBox.Show(BuildErrorMessage(ex),
-                      "Error - " + ex.GetType().Name,
-                      MessageBoxButtons.OK,
-                      MessageBoxIcon.Error);
-    }
-
-    private static string BuildErrorMessage(Exception ex) {
-      StringBuilder sb = new StringBuilder();
-      sb.Append("Sorry, but something went wrong!\n\n" + ex.Message + "\n\n" + ex.StackTrace);
-
-      while (ex.InnerException != null) {
-        ex = ex.InnerException;
-        sb.Append("\n\n-----\n\n" + ex.Message + "\n\n" + ex.StackTrace);
-      }
-      return sb.ToString();
+      HeuristicLab.PluginInfrastructure.Main.Run(args);
     }
   }
Index: /trunk/sources/HeuristicLab 3.3/Properties/Resources.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab 3.3/Properties/Resources.Designer.cs	(revision 2642)
+++ /trunk/sources/HeuristicLab 3.3/Properties/Resources.Designer.cs	(revision 2643)
@@ -9,5 +9,5 @@
 //------------------------------------------------------------------------------
 
-namespace HeuristicLab33.Properties {
+namespace HeuristicLab.Properties {
     using System;
     
@@ -40,5 +40,5 @@
             get {
                 if (object.ReferenceEquals(resourceMan, null)) {
-                    global::System.Resources.ResourceManager temp = new global::System.Resources.ResourceManager("HeuristicLab33.Properties.Resources", typeof(Resources).Assembly);
+                    global::System.Resources.ResourceManager temp = new global::System.Resources.ResourceManager("HeuristicLab.Properties.Resources", typeof(Resources).Assembly);
                     resourceMan = temp;
                 }
Index: /trunk/sources/HeuristicLab 3.3/Properties/Settings.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab 3.3/Properties/Settings.Designer.cs	(revision 2642)
+++ /trunk/sources/HeuristicLab 3.3/Properties/Settings.Designer.cs	(revision 2643)
@@ -9,5 +9,5 @@
 //------------------------------------------------------------------------------
 
-namespace HeuristicLab33.Properties {
+namespace HeuristicLab.Properties {
     
     
Index: /trunk/sources/HeuristicLab 3.3/Properties/Settings.settings
===================================================================
--- /trunk/sources/HeuristicLab 3.3/Properties/Settings.settings	(revision 2642)
+++ /trunk/sources/HeuristicLab 3.3/Properties/Settings.settings	(revision 2643)
@@ -1,4 +1,4 @@
 ﻿<?xml version='1.0' encoding='utf-8'?>
-<SettingsFile xmlns="http://schemas.microsoft.com/VisualStudio/2004/01/settings" CurrentProfile="(Default)" GeneratedClassNamespace="HeuristicLab33.Properties" GeneratedClassName="Settings">
+<SettingsFile xmlns="http://schemas.microsoft.com/VisualStudio/2004/01/settings" CurrentProfile="(Default)" GeneratedClassNamespace="HeuristicLab.Properties" GeneratedClassName="Settings">
   <Profiles />
   <Settings>
Index: /trunk/sources/HeuristicLab 3.3/app.config
===================================================================
--- /trunk/sources/HeuristicLab 3.3/app.config	(revision 2642)
+++ /trunk/sources/HeuristicLab 3.3/app.config	(revision 2643)
@@ -1,11 +1,16 @@
 <?xml version="1.0" encoding="utf-8" ?>
 <configuration>
-    <configSections>
-        <sectionGroup name="applicationSettings" type="System.Configuration.ApplicationSettingsGroup, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
-            <section name="HeuristicLab33.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" requirePermission="false" />
-        </sectionGroup>
-    </configSections>
+  <configSections>
+    <sectionGroup name="applicationSettings" type="System.Configuration.ApplicationSettingsGroup, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
+      <section name="HeuristicLab.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" requirePermission="false" />
+    </sectionGroup>
+  </configSections>
   <connectionStrings>
   </connectionStrings>
+  <system.serviceModel>
+  </system.serviceModel>
+  <runtime>
+    <gcServer enabled="true"/>
+  </runtime>
 
   <system.data>
@@ -22,5 +27,5 @@
   </system.data>
   <applicationSettings>
-    <HeuristicLab33.Properties.Settings>
+    <HeuristicLab.Properties.Settings>
       <setting name="User" serializeAs="String">
         <value>unknown</value>
@@ -29,5 +34,5 @@
         <value>unknown</value>
       </setting>
-    </HeuristicLab33.Properties.Settings>
+    </HeuristicLab.Properties.Settings>
   </applicationSettings>
 </configuration>