Index: trunk/sources/HeuristicLab.Operators/3.3/EmptyOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/EmptyOperator.cs	(revision 2591)
+++ trunk/sources/HeuristicLab.Operators/3.3/EmptyOperator.cs	(revision 2663)
@@ -23,31 +23,19 @@
 using System.Collections.Generic;
 using System.Text;
+using System.Xml;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Core;
 
 namespace HeuristicLab.Operators {
   /// <summary>
-  /// Placeholder and also used for testing; Does nothing.
+  /// An operator which represents an empty statement.
   /// </summary>
-  public class EmptyOperator : OperatorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return "An empty operator just does nothing. Useful for testing and as a place holder for sub-operators of SequentialSubScopesProcessor and ParallelSubScopesProcessor."; }
-    }
-
-    /// <summary>
-    /// Initializes a new instance of <see cref="EmptyOperator"/>.
-    /// </summary>
+  [Item("Empty Operator", "An operator which represents an empty statement.")]
+  [Creatable("Test")]
+  [EmptyStorableClass]
+  public sealed class EmptyOperator : StandardOperatorBase {
     public EmptyOperator()
       : base() {
     }
-
-    /// <summary>
-    /// Does nothing.
-    /// </summary>
-    /// <param name="scope">The scope to apply the operator on.</param>
-    /// <returns><c>null</c>.</returns>
-    public override IOperation Apply(IScope scope) {
-      return null;
-    }
   }
 }
Index: trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 2591)
+++ trunk/sources/HeuristicLab.Operators/3.3/HeuristicLab.Operators-3.3.csproj	(revision 2663)
@@ -85,61 +85,20 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="AddVariableInfoDialog.cs">
-      <SubType>Form</SubType>
-    </Compile>
-    <Compile Include="AddVariableInfoDialog.Designer.cs">
-      <DependentUpon>AddVariableInfoDialog.cs</DependentUpon>
-    </Compile>
-    <Compile Include="CombinedOperator.cs" />
-    <Compile Include="CombinedOperatorView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="CombinedOperatorView.Designer.cs">
-      <DependentUpon>CombinedOperatorView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="ComparatorBase.cs" />
-    <Compile Include="ConditionalBranch.cs">
+    <Compile Include="EmptyOperator.cs">
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="DelegatingOperator.cs" />
-    <Compile Include="DoubleCounter.cs" />
-    <Compile Include="ScopeCleaner.cs" />
-    <Compile Include="StochasticMultiBranch.cs" />
-    <Compile Include="SubScopesMixer.cs" />
-    <Compile Include="DataCollector.cs" />
-    <Compile Include="EqualToComparator.cs" />
-    <Compile Include="GreaterOrEqualThanComparator.cs" />
-    <Compile Include="GreaterThanComparator.cs" />
-    <Compile Include="LessOrEqualThanComparator.cs" />
-    <Compile Include="LessThanComparator.cs" />
-    <Compile Include="OperatorExtractor.cs" />
-    <Compile Include="ParallelProcessor.cs" />
-    <Compile Include="EmptyOperator.cs" />
-    <Compile Include="SequentialProcessor.cs" />
-    <Compile Include="SingleObjectiveEvaluatorBase.cs" />
-    <Compile Include="Sorter.cs" />
-    <Compile Include="StochasticBranch.cs" />
-    <Compile Include="SubScopesRemover.cs" />
-    <Compile Include="UnequalToComparator.cs" />
-    <Compile Include="UniformSequentialSubScopesProcessor.cs" />
-    <Compile Include="UniformParallelSubScopesProcessor.cs" />
-    <Compile Include="ParallelSubScopesProcessor.cs" />
-    <Compile Include="SequentialSubScopesProcessor.cs" />
-    <Compile Include="SubScopesCreater.cs" />
-    <Compile Include="Counter.cs" />
     <Compile Include="HeuristicLabOperatorsPlugin.cs" />
+    <Compile Include="OperatorBase.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="VariableInjector.cs" />
-    <Compile Include="VariableInjectorView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="VariableInjectorView.Designer.cs">
-      <DependentUpon>VariableInjectorView.cs</DependentUpon>
-    </Compile>
+    <Compile Include="StandardOperatorBase.cs" />
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.Core.Views\3.3\HeuristicLab.Core.Views-3.3.csproj">
-      <Project>{E226881D-315F-423D-B419-A766FE0D8685}</Project>
-      <Name>HeuristicLab.Core.Views-3.3</Name>
+    <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
+      <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
+      <Name>HeuristicLab.Collections-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Common.Resources\3.2\HeuristicLab.Common.Resources-3.2.csproj">
+      <Project>{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}</Project>
+      <Name>HeuristicLab.Common.Resources-3.2</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
@@ -150,12 +109,4 @@
       <Project>{BBAB9DF5-5EF3-4BA8-ADE9-B36E82114937}</Project>
       <Name>HeuristicLab.Data-3.3</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.MainForm.WindowsForms\3.2\HeuristicLab.MainForm.WindowsForms-3.2.csproj">
-      <Project>{AB687BBE-1BFE-476B-906D-44237135431D}</Project>
-      <Name>HeuristicLab.MainForm.WindowsForms-3.2</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.MainForm\3.2\HeuristicLab.MainForm-3.2.csproj">
-      <Project>{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}</Project>
-      <Name>HeuristicLab.MainForm-3.2</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
@@ -171,14 +122,4 @@
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.frame" />
-  </ItemGroup>
-  <ItemGroup>
-    <EmbeddedResource Include="AddVariableInfoDialog.resx">
-      <DependentUpon>AddVariableInfoDialog.cs</DependentUpon>
-      <SubType>Designer</SubType>
-    </EmbeddedResource>
-    <EmbeddedResource Include="CombinedOperatorView.resx">
-      <DependentUpon>CombinedOperatorView.cs</DependentUpon>
-      <SubType>Designer</SubType>
-    </EmbeddedResource>
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
Index: trunk/sources/HeuristicLab.Operators/3.3/HeuristicLabOperatorsPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/HeuristicLabOperatorsPlugin.cs	(revision 2591)
+++ trunk/sources/HeuristicLab.Operators/3.3/HeuristicLabOperatorsPlugin.cs	(revision 2663)
@@ -29,12 +29,11 @@
   /// Plugin class for HeuristicLab.Operators plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.Operators-3.3")]
-  [PluginFile(Filename = "HeuristicLab.Operators-3.3.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.3")]
-  [Dependency(Dependency = "HeuristicLab.Core.Views-3.3")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.3")]
-  [Dependency(Dependency = "HeuristicLab.MainForm-3.2")]
-  [Dependency(Dependency = "HeuristicLab.MainForm.WindowsForms-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Persistence-3.3")]  
+  [Plugin("HeuristicLab.Operators-3.3")]
+  [PluginFile("HeuristicLab.Operators-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Collections-3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources-3.2")]
+  [PluginDependency("HeuristicLab.Core-3.3")]
+  [PluginDependency("HeuristicLab.Data-3.3")]
+  [PluginDependency("HeuristicLab.Persistence-3.3")]  
   public class HeuristicLabOperatorsPlugin : PluginBase {
   }
Index: trunk/sources/HeuristicLab.Operators/3.3/OperatorBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/OperatorBase.cs	(revision 2663)
+++ trunk/sources/HeuristicLab.Operators/3.3/OperatorBase.cs	(revision 2663)
@@ -0,0 +1,156 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using System.Drawing;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Operators {
+  /// <summary>
+  /// The base class for all operators.
+  /// </summary>
+  [Item("OperatorBase", "Base class for operators.")]
+  public abstract class OperatorBase : NamedItemBase, IOperator {
+    public override Image ItemImage {
+      get { return HeuristicLab.Common.Resources.VS2008ImageLibrary.Method; }
+    }
+
+    private ParameterCollection parameters;
+    [Storable]
+    protected ParameterCollection Parameters {
+      get { return parameters;}
+      private set {
+        if (parameters != null) parameters.Changed -= new ChangedEventHandler(Parameters_Changed);
+        parameters = value;
+        readOnlyParameters = null;
+        if (parameters != null) parameters.Changed += new ChangedEventHandler(Parameters_Changed);
+      }
+    }
+    private ReadOnlyObservableKeyedCollection<string, IParameter> readOnlyParameters;
+    IObservableKeyedCollection<string, IParameter> IOperator.Parameters {
+      get {
+        if (readOnlyParameters == null) readOnlyParameters = parameters.AsReadOnly();
+        return readOnlyParameters;
+      }
+    }
+
+    /// <summary>
+    /// Flag whether the current instance has been canceled.
+    /// </summary>
+    private bool canceled;
+    /// <inheritdoc/>
+    protected bool Canceled {
+      get { return canceled; }
+    }
+
+    [Storable]
+    private bool breakpoint;
+    /// <inheritdoc/>
+    /// <remarks>Calls <see cref="OnBreakpointChanged"/> in the setter.</remarks>
+    public bool Breakpoint {
+      get { return breakpoint; }
+      set {
+        if (value != breakpoint) {
+          breakpoint = value;
+          OnBreakpointChanged();
+        }
+      }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="OperatorBase"/> setting the breakpoint flag and 
+    /// the canceled flag to <c>false</c> and the name of the operator to the type name. 
+    /// </summary>
+    protected OperatorBase() {
+      name = ItemName;
+      Parameters = new ParameterCollection();
+      readOnlyParameters = null;
+      canceled = false;
+      breakpoint = false;
+    }
+
+    /// <summary>
+    /// Clones the current instance (deep clone).
+    /// </summary>
+    /// <remarks>Clones also sub operators, variables and variable infos.</remarks>
+    /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
+    /// <returns>The cloned object as <see cref="OperatorBase"/>.</returns>
+    public override IDeepCloneable Clone(Cloner cloner) {
+      OperatorBase clone = (OperatorBase)base.Clone(cloner);
+      clone.Parameters = (ParameterCollection)cloner.Clone(parameters);
+      clone.canceled = canceled;
+      clone.breakpoint = breakpoint;
+      return clone;
+    }
+
+    /// <inheritdoc/>
+    public virtual ExecutionContextCollection Execute(ExecutionContext context) {
+      canceled = false;
+      ExecutionContextCollection next = Apply(context);
+      OnExecuted();
+      return next;
+    }
+    /// <inheritdoc/>
+    /// <remarks>Sets property <see cref="Canceled"/> to <c>true</c>.</remarks>
+    public virtual void Abort() {
+      canceled = true;
+    }
+    /// <summary>
+    /// Performs the current operator on the specified <paramref name="scope"/>.
+    /// </summary>
+    /// <param name="scope">The scope where to execute the operator</param>
+    /// <returns><c>null</c>.</returns>
+    public virtual ExecutionContextCollection Apply(ExecutionContext context) {
+      return new ExecutionContextCollection();
+    }
+
+    /// <inheritdoc/>
+    public event EventHandler BreakpointChanged;
+    /// <summary>
+    /// Fires a new <c>BreakpointChanged</c> event.
+    /// </summary>
+    protected virtual void OnBreakpointChanged() {
+      if (BreakpointChanged != null) {
+        BreakpointChanged(this, new EventArgs());
+      }
+      OnChanged();
+    }
+    /// <inheritdoc/>
+    public event EventHandler Executed;
+    /// <summary>
+    /// Fires a new <c>Executed</c> event.
+    /// </summary>
+    protected virtual void OnExecuted() {
+      if (Executed != null) {
+        Executed(this, new EventArgs());
+      }
+    }
+
+    private void Parameters_Changed(object sender, ChangedEventArgs e) {
+      OnChanged(e);
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Operators/3.3/Properties/AssemblyInfo.frame
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/Properties/AssemblyInfo.frame	(revision 2591)
+++ trunk/sources/HeuristicLab.Operators/3.3/Properties/AssemblyInfo.frame	(revision 2663)
@@ -29,5 +29,5 @@
 // associated with an assembly.
 [assembly: AssemblyTitle("HeuristicLab.Operators")]
-[assembly: AssemblyDescription("Various HeuristicLab operator classes")]
+[assembly: AssemblyDescription("HeuristicLab operator classes")]
 [assembly: AssemblyConfiguration("")]
 [assembly: AssemblyCompany("")]
Index: trunk/sources/HeuristicLab.Operators/3.3/StandardOperatorBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators/3.3/StandardOperatorBase.cs	(revision 2663)
+++ trunk/sources/HeuristicLab.Operators/3.3/StandardOperatorBase.cs	(revision 2663)
@@ -0,0 +1,54 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Operators {
+  /// <summary>
+  /// A base class for operators which have only one successor.
+  /// </summary>
+  [Item("StandardOperatorBase", "A base class for operators which have only one successor.")]
+  [Creatable("Test")]
+  [EmptyStorableClass]
+  public abstract class StandardOperatorBase : OperatorBase {
+    public OperatorParameter Successor {
+      get { return (OperatorParameter)Parameters["Successor"]; }
+    }
+
+    public StandardOperatorBase()
+      : base() {
+      Parameters.Add(new OperatorParameter("Successor", "Operator which is executed next"));
+    }
+
+    public override ExecutionContextCollection Apply(ExecutionContext context) {
+      IOperator successor = Successor.GetValue(context);
+      if (successor != null)
+        return new ExecutionContextCollection(new ExecutionContext(context.Parent, successor, context.Scope));
+      else
+        return new ExecutionContextCollection();
+    }
+  }
+}